#include "include.h"
#include "socket_msg.h"


int socket_msg_marshal(struct socket_msg *src, char dest[REQUEST_MAXLEN]) {
	uint32_t nl = 0;
	uint16_t ns = 0;
	int pos = 0;

	nl = htonl(src->type);
	memcpy(dest + pos, &nl, sizeof(nl));
	pos += sizeof(nl);

	if (src->type & SOCKET_MSG_TYPE_CLIENT) {
		memcpy(dest + pos, src->client->addr, sizeof(src->client->addr));
		pos += sizeof(src->client->addr);

		nl = htonl(src->client->time);
		memcpy(dest + pos, &nl, sizeof(nl));
		pos += sizeof(nl);

		ns = htons(src->client->try_probe);
		memcpy(dest + pos, &ns, sizeof(ns));
		pos += sizeof(ns);

		ns = htons(src->client->try_auth);
		memcpy(dest + pos, &ns, sizeof(ns));
		pos += sizeof(ns);

		memcpy(dest + pos, &src->client->connected, sizeof(src->client->connected));
		pos += sizeof(src->client->connected);

		memcpy(dest + pos, &src->client->authed, sizeof(src->client->authed));
		pos += sizeof(src->client->authed);

		ns = htons(src->client->freq_highest);
		memcpy(dest + pos, &ns, sizeof(ns));
		pos += sizeof(ns);

		ns = htons(src->client->signal_lowfreq);
		memcpy(dest + pos, &ns, sizeof(ns));
		pos += sizeof(ns);

		ns = htons(src->client->signal_highfreq);
		memcpy(dest + pos, &ns, sizeof(ns));
		pos += sizeof(ns);

	}
	memset(dest + pos, 0, REQUEST_MAXLEN-pos);

	return 0;
}

int socket_msg_unmarshal(struct socket_msg *dest, char src[REQUEST_MAXLEN]) {
	uint32_t nl = 0;
	uint16_t ns = 0;
	int pos = 0;

	memcpy(&nl, src + pos, sizeof(nl));
	pos += sizeof(nl);
	dest->type = ntohl(nl);

	if (dest->type & SOCKET_MSG_TYPE_CLIENT) {
		memcpy(dest->client->addr, src + pos, sizeof(dest->client->addr));
		pos += sizeof(dest->client->addr);

		memcpy(&nl, src + pos, sizeof(nl));
		pos += sizeof(nl);
		dest->client->time = ntohl(nl);

		memcpy(&ns, src + pos, sizeof(ns));
		pos += sizeof(ns);
		dest->client->try_probe = ntohs(ns);

		memcpy(&ns, src + pos, sizeof(ns));
		pos += sizeof(ns);
		dest->client->try_auth = ntohs(ns);

		memcpy(&dest->client->connected, src + pos, sizeof(dest->client->connected));
		pos += sizeof(dest->client->connected);

		memcpy(&dest->client->authed, src + pos, sizeof(dest->client->authed));
		pos += sizeof(dest->client->authed);

		memcpy(&ns, src + pos, sizeof(ns));
		pos += sizeof(ns);
		dest->client->freq_highest = ntohs(ns);

		memcpy(&ns, src + pos, sizeof(ns));
		pos += sizeof(ns);
		dest->client->signal_lowfreq = ntohs(ns);

		memcpy(&ns, src + pos, sizeof(ns));
		pos += sizeof(ns);
		dest->client->signal_highfreq = ntohs(ns);
	}
	return 0;
}
